import { EditorApi } from "../../types/monaco";
import { CompilerInfo } from "../../types/solidity";
import { EditorInitState } from "../editorContext";
declare class ParserVersion {
    editorApi: EditorApi;
    editorState: EditorInitState;
    allVersions: string[];
    latestVersion: string;
    compilerInfo?: CompilerInfo;
    constructor(editorApi: EditorApi, editorState: EditorInitState);
    init(): Promise<void>;
    resolveCodeVersion(code: string): string;
    getVersionUri(version: string): string | undefined;
    matchVersion(version: string): string;
    getCompilerInfo(): Promise<CompilerInfo>;
    setVersion(): void;
}
export default ParserVersion;
