import { Monaco } from '@monaco-editor/react';
import { BaseMonacoEditor, EditorApi, ModelInfoType, ModelType } from '../types/monaco';
import { EditorInitState } from './editorContext';
declare function initTheme(monaco: Monaco): void;
declare function initModels(monaco: Monaco, editor: BaseMonacoEditor, modelInfos: ModelInfoType[], dispatch: any, overWriteExisting?: boolean): void;
declare function registerLangs(monaco: Monaco, state: EditorInitState): void;
declare function registerCommandsAndActions(monaco: Monaco, editor: BaseMonacoEditor): void;
declare function registerFileCompletion(monaco: Monaco): void;
declare function registerFileImports(monaco: Monaco, state: any): void;
declare function registerListeners(editor: BaseMonacoEditor, editorApi: EditorApi, editorState: EditorInitState): void;
declare function addModels(monaco: Monaco, editor: BaseMonacoEditor, modelIndex: number, modelInfos: ModelInfoType[], currentModels: ModelType[], dispatch: any, overWriteExisting?: boolean): void;
declare function getCursorPosition(monaco: Monaco, state: EditorInitState, offset?: boolean): number | import("monaco-editor").Position | null | undefined;
export { initTheme, initModels, registerLangs, registerCommandsAndActions, addModels, getCursorPosition, registerFileCompletion, registerFileImports, registerListeners };
