import { CompilationResult, visitContractsCallbackInterface, ErrorMarker, SearchResultLine } from './types';
/**
 * @dev Get contract obj of given contract name from last compilation result.
 * @param name contract name
 * @param contracts 'contracts' object from last compilation result
 */
export declare const getContract: (contractName: string, contracts: CompilationResult['contracts']) => Record<string, any> | null;
/**
 * @dev call the given callback for all contracts from last compilation result, stop visiting when cb return true
 * @param contracts - 'contracts' object from last compilation result
 * @param cb    - callback
 */
export declare const visitContracts: (contracts: CompilationResult['contracts'], cb: visitContractsCallbackInterface) => void;
export declare const getPositionDetails: (msg: string) => Record<string, string | number>;
export declare const createErrorMarker: (error: any, filePath: string, lineColumn: any) => ErrorMarker;
export declare const getLinebreakPositions: (source: any) => any[];
export declare const convertOffsetToLineColumn: (sourceLocation: any, lineBreakPositions: any) => {
    start: {
        line: number;
        column: number;
    };
    end: {
        line: number;
        column: number;
    };
} | {
    start: null;
    end: null;
};
export declare const convertFromCharPosition: (pos: any, lineBreakPositions: any) => {
    line: number;
    column: number;
};
export declare const findLowerBound: (target: any, array: any) => number;
export declare const getPositionForImportErrors: (importedFileName: string, text: string) => Promise<SearchResultLine[]>;
export declare const findLinesInStringWithMatch: (str: string, re: RegExp) => SearchResultLine[];
