import React, { useReducer, useRef, useMemo, useEffect, useCallback, useState } from 'react';
import { useDrag, useDrop, DndProvider } from 'react-dnd';
import { HTML5Backend } from 'react-dnd-html5-backend';
import ReactBaseMonacoEditor from '@monaco-editor/react';
import { makeStyles as makeStyles$1 } from '@material-ui/core/styles';
import PlayArrowIcon from '@material-ui/icons/PlayArrow';
import { makeStyles } from '@material-ui/core';
import useOnclickOutside from 'react-cool-onclickoutside';
import IconButton from '@material-ui/core/IconButton';
import AddIconComponent from '@material-ui/icons/Add';
import { styled } from '@material-ui/styles';
import setupMethods from 'solc/wrapper';
import semver from 'semver';

function _regeneratorRuntime() {
  _regeneratorRuntime = function () {
    return exports;
  };
  var exports = {},
    Op = Object.prototype,
    hasOwn = Op.hasOwnProperty,
    defineProperty = Object.defineProperty || function (obj, key, desc) {
      obj[key] = desc.value;
    },
    $Symbol = "function" == typeof Symbol ? Symbol : {},
    iteratorSymbol = $Symbol.iterator || "@@iterator",
    asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator",
    toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";
  function define(obj, key, value) {
    return Object.defineProperty(obj, key, {
      value: value,
      enumerable: !0,
      configurable: !0,
      writable: !0
    }), obj[key];
  }
  try {
    define({}, "");
  } catch (err) {
    define = function (obj, key, value) {
      return obj[key] = value;
    };
  }
  function wrap(innerFn, outerFn, self, tryLocsList) {
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator,
      generator = Object.create(protoGenerator.prototype),
      context = new Context(tryLocsList || []);
    return defineProperty(generator, "_invoke", {
      value: makeInvokeMethod(innerFn, self, context)
    }), generator;
  }
  function tryCatch(fn, obj, arg) {
    try {
      return {
        type: "normal",
        arg: fn.call(obj, arg)
      };
    } catch (err) {
      return {
        type: "throw",
        arg: err
      };
    }
  }
  exports.wrap = wrap;
  var ContinueSentinel = {};
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}
  var IteratorPrototype = {};
  define(IteratorPrototype, iteratorSymbol, function () {
    return this;
  });
  var getProto = Object.getPrototypeOf,
    NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype);
  var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function (method) {
      define(prototype, method, function (arg) {
        return this._invoke(method, arg);
      });
    });
  }
  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);
      if ("throw" !== record.type) {
        var result = record.arg,
          value = result.value;
        return value && "object" == typeof value && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) {
          invoke("next", value, resolve, reject);
        }, function (err) {
          invoke("throw", err, resolve, reject);
        }) : PromiseImpl.resolve(value).then(function (unwrapped) {
          result.value = unwrapped, resolve(result);
        }, function (error) {
          return invoke("throw", error, resolve, reject);
        });
      }
      reject(record.arg);
    }
    var previousPromise;
    defineProperty(this, "_invoke", {
      value: function (method, arg) {
        function callInvokeWithMethodAndArg() {
          return new PromiseImpl(function (resolve, reject) {
            invoke(method, arg, resolve, reject);
          });
        }
        return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      }
    });
  }
  function makeInvokeMethod(innerFn, self, context) {
    var state = "suspendedStart";
    return function (method, arg) {
      if ("executing" === state) throw new Error("Generator is already running");
      if ("completed" === state) {
        if ("throw" === method) throw arg;
        return doneResult();
      }
      for (context.method = method, context.arg = arg;;) {
        var delegate = context.delegate;
        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);
          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }
        if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) {
          if ("suspendedStart" === state) throw state = "completed", context.arg;
          context.dispatchException(context.arg);
        } else "return" === context.method && context.abrupt("return", context.arg);
        state = "executing";
        var record = tryCatch(innerFn, self, context);
        if ("normal" === record.type) {
          if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue;
          return {
            value: record.arg,
            done: context.done
          };
        }
        "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg);
      }
    };
  }
  function maybeInvokeDelegate(delegate, context) {
    var methodName = context.method,
      method = delegate.iterator[methodName];
    if (undefined === method) return context.delegate = null, "throw" === methodName && delegate.iterator.return && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method) || "return" !== methodName && (context.method = "throw", context.arg = new TypeError("The iterator does not provide a '" + methodName + "' method")), ContinueSentinel;
    var record = tryCatch(method, delegate.iterator, context.arg);
    if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel;
    var info = record.arg;
    return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel);
  }
  function pushTryEntry(locs) {
    var entry = {
      tryLoc: locs[0]
    };
    1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry);
  }
  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal", delete record.arg, entry.completion = record;
  }
  function Context(tryLocsList) {
    this.tryEntries = [{
      tryLoc: "root"
    }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0);
  }
  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) return iteratorMethod.call(iterable);
      if ("function" == typeof iterable.next) return iterable;
      if (!isNaN(iterable.length)) {
        var i = -1,
          next = function next() {
            for (; ++i < iterable.length;) if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next;
            return next.value = undefined, next.done = !0, next;
          };
        return next.next = next;
      }
    }
    return {
      next: doneResult
    };
  }
  function doneResult() {
    return {
      value: undefined,
      done: !0
    };
  }
  return GeneratorFunction.prototype = GeneratorFunctionPrototype, defineProperty(Gp, "constructor", {
    value: GeneratorFunctionPrototype,
    configurable: !0
  }), defineProperty(GeneratorFunctionPrototype, "constructor", {
    value: GeneratorFunction,
    configurable: !0
  }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) {
    var ctor = "function" == typeof genFun && genFun.constructor;
    return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name));
  }, exports.mark = function (genFun) {
    return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun;
  }, exports.awrap = function (arg) {
    return {
      __await: arg
    };
  }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
    return this;
  }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    void 0 === PromiseImpl && (PromiseImpl = Promise);
    var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
    return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
      return result.done ? result.value : iter.next();
    });
  }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () {
    return this;
  }), define(Gp, "toString", function () {
    return "[object Generator]";
  }), exports.keys = function (val) {
    var object = Object(val),
      keys = [];
    for (var key in object) keys.push(key);
    return keys.reverse(), function next() {
      for (; keys.length;) {
        var key = keys.pop();
        if (key in object) return next.value = key, next.done = !1, next;
      }
      return next.done = !0, next;
    };
  }, exports.values = values, Context.prototype = {
    constructor: Context,
    reset: function (skipTempReset) {
      if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined);
    },
    stop: function () {
      this.done = !0;
      var rootRecord = this.tryEntries[0].completion;
      if ("throw" === rootRecord.type) throw rootRecord.arg;
      return this.rval;
    },
    dispatchException: function (exception) {
      if (this.done) throw exception;
      var context = this;
      function handle(loc, caught) {
        return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught;
      }
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i],
          record = entry.completion;
        if ("root" === entry.tryLoc) return handle("end");
        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc"),
            hasFinally = hasOwn.call(entry, "finallyLoc");
          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
          } else {
            if (!hasFinally) throw new Error("try statement without catch or finally");
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          }
        }
      }
    },
    abrupt: function (type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }
      finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null);
      var record = finallyEntry ? finallyEntry.completion : {};
      return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record);
    },
    complete: function (record, afterLoc) {
      if ("throw" === record.type) throw record.arg;
      return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel;
    },
    finish: function (finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel;
      }
    },
    catch: function (tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;
          if ("throw" === record.type) {
            var thrown = record.arg;
            resetTryEntry(entry);
          }
          return thrown;
        }
      }
      throw new Error("illegal catch attempt");
    },
    delegateYield: function (iterable, resultName, nextLoc) {
      return this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      }, "next" === this.method && (this.arg = undefined), ContinueSentinel;
    }
  }, exports;
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }
  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}
function _asyncToGenerator(fn) {
  return function () {
    var self = this,
      args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);
      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }
      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }
      _next(undefined);
    });
  };
}
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}
function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
  if (it) return (it = it.call(o)).next.bind(it);
  if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
    if (it) o = it;
    var i = 0;
    return function () {
      if (i >= o.length) return {
        done: true
      };
      return {
        done: false,
        value: o[i++]
      };
    };
  }
  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var EditorContext = /*#__PURE__*/React.createContext(undefined);
// Editor Reducer And State
var editorInitState = {
  editor: undefined,
  monaco: undefined,
  models: [],
  modelIndex: 0,
  consoleMessages: [],
  codeParser: {},
  codeParserInitLoading: false
};
var editorReducer = function editorReducer(state, action) {
  switch (action.type) {
    case "updateEditor":
      return _extends({}, state, {
        editor: action.payload.editor
      });
    case "updateMonaco":
      return _extends({}, state, {
        monaco: action.payload.monaco
      });
    case "updateModels":
      return _extends({}, state, {
        models: action.payload.models
      });
    case "updateModelIndex":
      return _extends({}, state, {
        modelIndex: action.payload.modelIndex
      });
    case "updateConsoleMessages":
      return _extends({}, state, {
        consoleMessages: action.payload.consoleMessages || []
      });
    case "setCodeParser":
      return _extends({}, state, {
        codeParser: action.payload.codeParser || {}
      });
    case "updateCodeParserLoading":
      return _extends({}, state, {
        codeParserInitLoading: action.payload.codeParserInitLoading || false
      });
    default:
      return state;
  }
};
// Editor Provider
function EditorProvider(_ref) {
  var children = _ref.children;
  var _useReducer = useReducer(editorReducer, editorInitState),
    state = _useReducer[0],
    dispatch = _useReducer[1];
  // some provider need to access the state directly
  var stateRef = useRef(state || {});
  var actions = useMemo(function () {
    return {
      updateEditor: function updateEditor(editor) {
        return dispatch({
          type: "updateEditor",
          payload: {
            editor: editor
          }
        });
      },
      updateMonaco: function updateMonaco(monaco) {
        return dispatch({
          type: "updateMonaco",
          payload: {
            monaco: monaco
          }
        });
      },
      updateModels: function updateModels(models) {
        return dispatch({
          type: "updateModels",
          payload: {
            models: models
          }
        });
      },
      updateModelIndex: function updateModelIndex(modelIndex) {
        return dispatch({
          type: "updateModelIndex",
          payload: {
            modelIndex: modelIndex
          }
        });
      },
      updateConsoleMessages: function updateConsoleMessages(consoleMessages) {
        return dispatch({
          type: "updateConsoleMessages",
          payload: {
            consoleMessages: consoleMessages
          }
        });
      },
      setCodeParser: function setCodeParser(codeParser) {
        return dispatch({
          type: "setCodeParser",
          payload: {
            codeParser: codeParser
          }
        });
      },
      updateCodeParserLoading: function updateCodeParserLoading(codeParserInitLoading) {
        return dispatch({
          type: "updateCodeParserLoading",
          payload: {
            codeParserInitLoading: codeParserInitLoading
          }
        });
      },
      cleanModels: function cleanModels() {
        return dispatch({
          type: "updateModels",
          payload: {
            models: []
          }
        });
      },
      cleanConsoleMessages: function cleanConsoleMessages() {
        return dispatch({
          type: "updateConsoleMessages",
          payload: {
            consoleMessages: []
          }
        });
      }
    };
  }, []);
  useEffect(function () {
    stateRef.current = Object.assign(stateRef.current, state || {});
  }, [state]);
  return React.createElement(EditorContext.Provider, {
    value: {
      state: state,
      dispatch: dispatch,
      stateRef: stateRef,
      actions: actions
    }
  }, children);
}
function useEditor() {
  var context = React.useContext(EditorContext);
  if (context === undefined) {
    throw new Error("useEditor must be used withing a provider");
  }
  return context;
}

var CompilerRetriggerMode;
(function (CompilerRetriggerMode) {
  CompilerRetriggerMode[CompilerRetriggerMode["none"] = 0] = "none";
  CompilerRetriggerMode[CompilerRetriggerMode["retrigger"] = 1] = "retrigger";
})(CompilerRetriggerMode || (CompilerRetriggerMode = {}));
var MarkerSeverity;
(function (MarkerSeverity) {
  MarkerSeverity[MarkerSeverity["Hint"] = 1] = "Hint";
  MarkerSeverity[MarkerSeverity["Info"] = 2] = "Info";
  MarkerSeverity[MarkerSeverity["Warning"] = 4] = "Warning";
  MarkerSeverity[MarkerSeverity["Error"] = 8] = "Error";
})(MarkerSeverity || (MarkerSeverity = {}));

var createErrorMarker = function createErrorMarker(error, filePath, lineColumn) {
  return {
    message: error.formattedMessage,
    severity: error.severity === 'error' ? MarkerSeverity.Error : MarkerSeverity.Warning,
    position: {
      start: {
        line: (lineColumn.start && lineColumn.start.line || 0) + 1,
        column: (lineColumn.start && lineColumn.start.column || 0) + 1
      },
      end: {
        line: (lineColumn.end && lineColumn.end.line || 0) + 1,
        column: (lineColumn.end && lineColumn.end.column || 0) + 1
      }
    },
    file: filePath
  };
};
var getLinebreakPositions = function getLinebreakPositions(source) {
  var ret = [];
  for (var pos = source.indexOf('\n'); pos >= 0; pos = source.indexOf('\n', pos + 1)) {
    ret.push(pos);
  }
  return ret;
};
var convertOffsetToLineColumn = function convertOffsetToLineColumn(sourceLocation, lineBreakPositions) {
  if (sourceLocation.start >= 0 && sourceLocation.length >= 0) {
    return {
      start: convertFromCharPosition(sourceLocation.start, lineBreakPositions),
      end: convertFromCharPosition(sourceLocation.start + sourceLocation.length, lineBreakPositions)
    };
  }
  return {
    start: null,
    end: null
  };
};
var convertFromCharPosition = function convertFromCharPosition(pos, lineBreakPositions) {
  var line = findLowerBound(pos, lineBreakPositions);
  if (lineBreakPositions[line] !== pos) {
    line = line + 1;
  }
  var beginColumn = line === 0 ? 0 : lineBreakPositions[line - 1] + 1;
  var column = pos - beginColumn;
  return {
    line: line,
    column: column
  };
};
var findLowerBound = function findLowerBound(target, array) {
  var start = 0;
  var length = array.length;
  while (length > 0) {
    var half = length >> 1;
    var middle = start + half;
    if (array[middle] <= target) {
      length = length - 1 - half;
      start = middle + 1;
    } else {
      length = half;
    }
  }
  return start - 1;
};
var getPositionForImportErrors = /*#__PURE__*/function () {
  var _ref = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(importedFileName, text) {
    var re, result;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          re = new RegExp(escapeRegExp(importedFileName), 'gi');
          result = findLinesInStringWithMatch(text, re);
          return _context.abrupt("return", result);
        case 3:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return function getPositionForImportErrors(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();
var findLinesInStringWithMatch = function findLinesInStringWithMatch(str, re) {
  return str.split(/\r?\n/).map(function (line, i) {
    var matchResult = matchesInString(line, re);
    if (matchResult.length) {
      return {
        lines: splitLines(matchResult, i)
      };
    }
    return null;
  }).filter(Boolean);
};
var matchesInString = function matchesInString(str, re) {
  var a;
  var results = [];
  // @ts-ignore
  while ((a = re.exec(str || '')) !== null) {
    results.push(a);
  }
  return results;
};
var splitLines = function splitLines(matchResult, lineNumber) {
  return matchResult.map(function (matchResultPart, i) {
    var result = {
      left: matchResultPart.input.substring(0, matchResultPart.index),
      right: matchResultPart.input.substring(matchResultPart.index + matchResultPart[0].length),
      center: matchResultPart[0],
      position: {
        start: {
          line: lineNumber,
          column: matchResultPart.index
        },
        end: {
          line: lineNumber,
          column: matchResultPart.index + matchResultPart[0].length
        }
      }
    };
    return result;
  });
};
var escapeRegExp = function escapeRegExp(str) {
  return str.replace(/[.*+?^${}()|[\]\\]/g, '\\$&');
};

var SupportLanguage;
(function (SupportLanguage) {
  SupportLanguage["Solidity"] = "solidity";
})(SupportLanguage || (SupportLanguage = {}));
var ModelInfoType = function ModelInfoType(_temp) {
  var _ref = _temp === void 0 ? {} : _temp,
    _ref$notInitial = _ref.notInitial,
    notInitial = _ref$notInitial === void 0 ? false : _ref$notInitial,
    _ref$shown = _ref.shown,
    shown = _ref$shown === void 0 ? false : _ref$shown,
    _ref$readOnly = _ref.readOnly,
    readOnly = _ref$readOnly === void 0 ? false : _ref$readOnly,
    _ref$tested = _ref.tested,
    tested = _ref$tested === void 0 ? false : _ref$tested,
    _ref$filename = _ref.filename,
    filename = _ref$filename === void 0 ? '' : _ref$filename,
    _ref$value = _ref.value,
    value = _ref$value === void 0 ? '' : _ref$value,
    _ref$language = _ref.language,
    language = _ref$language === void 0 ? SupportLanguage.Solidity : _ref$language;
  this.filename = '';
  this.value = '';
  this.language = SupportLanguage.Solidity;
  this.filename = filename;
  this.value = value;
  this.language = language;
  this.notInitial = notInitial;
  this.shown = shown;
  this.readOnly = readOnly;
  this.tested = tested;
};

var DefinitionProvider = /*#__PURE__*/function () {
  function DefinitionProvider(monaco, state) {
    this.monaco = monaco;
    this.state = state;
  }
  var _proto = DefinitionProvider.prototype;
  _proto.provideDefinition = function provideDefinition(model, position, token) {
    // throw new Error('Method not implemented.');
    return null;
  };
  return DefinitionProvider;
}();

/* eslint-disable */
var solidityLanguageConfig = {
  comments: {
    lineComment: '//',
    blockComment: ['/*', '*/']
  },
  brackets: [['{', '}'], ['[', ']'], ['(', ')'], ['<', '>']],
  autoClosingPairs: [{
    open: '"',
    close: '"',
    notIn: ['string', 'comment']
  }, {
    open: "'",
    close: "'",
    notIn: ['string', 'comment']
  }, {
    open: '{',
    close: '}',
    notIn: ['string', 'comment']
  }, {
    open: '[',
    close: ']',
    notIn: ['string', 'comment']
  }, {
    open: '(',
    close: ')',
    notIn: ['string', 'comment']
  }]
};
var solidityTokensProvider = {
  defaultToken: '',
  tokenPostfix: '.sol',
  brackets: [{
    token: 'delimiter.curly',
    open: '{',
    close: '}'
  }, {
    token: 'delimiter.parenthesis',
    open: '(',
    close: ')'
  }, {
    token: 'delimiter.square',
    open: '[',
    close: ']'
  }, {
    token: 'delimiter.angle',
    open: '<',
    close: '>'
  }],
  keywords: [
  // Main keywords
  'pragma', 'solidity', 'contract', 'library', 'using', 'struct', 'function', 'modifier', 'constructor',
  // Built-in types
  'address', 'string', 'bool',
  // Other types
  'Int', 'Uint', 'Byte', 'Fixed', 'Ufixed',
  // All int
  'int', 'int8', 'int16', 'int24', 'int32', 'int40', 'int48', 'int56', 'int64', 'int72', 'int80', 'int88', 'int96', 'int104', 'int112', 'int120', 'int128', 'int136', 'int144', 'int152', 'int160', 'int168', 'int176', 'int184', 'int192', 'int200', 'int208', 'int216', 'int224', 'int232', 'int240', 'int248', 'int256',
  // All uint
  'uint', 'uint8', 'uint16', 'uint24', 'uint32', 'uint40', 'uint48', 'uint56', 'uint64', 'uint72', 'uint80', 'uint88', 'uint96', 'uint104', 'uint112', 'uint120', 'uint128', 'uint136', 'uint144', 'uint152', 'uint160', 'uint168', 'uint176', 'uint184', 'uint192', 'uint200', 'uint208', 'uint216', 'uint224', 'uint232', 'uint240', 'uint248', 'uint256',
  // All Byte
  'byte', 'bytes', 'bytes1', 'bytes2', 'bytes3', 'bytes4', 'bytes5', 'bytes6', 'bytes7', 'bytes8', 'bytes9', 'bytes10', 'bytes11', 'bytes12', 'bytes13', 'bytes14', 'bytes15', 'bytes16', 'bytes17', 'bytes18', 'bytes19', 'bytes20', 'bytes21', 'bytes22', 'bytes23', 'bytes24', 'bytes25', 'bytes26', 'bytes27', 'bytes28', 'bytes29', 'bytes30', 'bytes31', 'bytes32',
  // All fixed
  'fixed', 'fixed0x8', 'fixed0x16', 'fixed0x24', 'fixed0x32', 'fixed0x40', 'fixed0x48', 'fixed0x56', 'fixed0x64', 'fixed0x72', 'fixed0x80', 'fixed0x88', 'fixed0x96', 'fixed0x104', 'fixed0x112', 'fixed0x120', 'fixed0x128', 'fixed0x136', 'fixed0x144', 'fixed0x152', 'fixed0x160', 'fixed0x168', 'fixed0x176', 'fixed0x184', 'fixed0x192', 'fixed0x200', 'fixed0x208', 'fixed0x216', 'fixed0x224', 'fixed0x232', 'fixed0x240', 'fixed0x248', 'fixed0x256', 'fixed8x8', 'fixed8x16', 'fixed8x24', 'fixed8x32', 'fixed8x40', 'fixed8x48', 'fixed8x56', 'fixed8x64', 'fixed8x72', 'fixed8x80', 'fixed8x88', 'fixed8x96', 'fixed8x104', 'fixed8x112', 'fixed8x120', 'fixed8x128', 'fixed8x136', 'fixed8x144', 'fixed8x152', 'fixed8x160', 'fixed8x168', 'fixed8x176', 'fixed8x184', 'fixed8x192', 'fixed8x200', 'fixed8x208', 'fixed8x216', 'fixed8x224', 'fixed8x232', 'fixed8x240', 'fixed8x248', 'fixed16x8', 'fixed16x16', 'fixed16x24', 'fixed16x32', 'fixed16x40', 'fixed16x48', 'fixed16x56', 'fixed16x64', 'fixed16x72', 'fixed16x80', 'fixed16x88', 'fixed16x96', 'fixed16x104', 'fixed16x112', 'fixed16x120', 'fixed16x128', 'fixed16x136', 'fixed16x144', 'fixed16x152', 'fixed16x160', 'fixed16x168', 'fixed16x176', 'fixed16x184', 'fixed16x192', 'fixed16x200', 'fixed16x208', 'fixed16x216', 'fixed16x224', 'fixed16x232', 'fixed16x240', 'fixed24x8', 'fixed24x16', 'fixed24x24', 'fixed24x32', 'fixed24x40', 'fixed24x48', 'fixed24x56', 'fixed24x64', 'fixed24x72', 'fixed24x80', 'fixed24x88', 'fixed24x96', 'fixed24x104', 'fixed24x112', 'fixed24x120', 'fixed24x128', 'fixed24x136', 'fixed24x144', 'fixed24x152', 'fixed24x160', 'fixed24x168', 'fixed24x176', 'fixed24x184', 'fixed24x192', 'fixed24x200', 'fixed24x208', 'fixed24x216', 'fixed24x224', 'fixed24x232', 'fixed32x8', 'fixed32x16', 'fixed32x24', 'fixed32x32', 'fixed32x40', 'fixed32x48', 'fixed32x56', 'fixed32x64', 'fixed32x72', 'fixed32x80', 'fixed32x88', 'fixed32x96', 'fixed32x104', 'fixed32x112', 'fixed32x120', 'fixed32x128', 'fixed32x136', 'fixed32x144', 'fixed32x152', 'fixed32x160', 'fixed32x168', 'fixed32x176', 'fixed32x184', 'fixed32x192', 'fixed32x200', 'fixed32x208', 'fixed32x216', 'fixed32x224', 'fixed40x8', 'fixed40x16', 'fixed40x24', 'fixed40x32', 'fixed40x40', 'fixed40x48', 'fixed40x56', 'fixed40x64', 'fixed40x72', 'fixed40x80', 'fixed40x88', 'fixed40x96', 'fixed40x104', 'fixed40x112', 'fixed40x120', 'fixed40x128', 'fixed40x136', 'fixed40x144', 'fixed40x152', 'fixed40x160', 'fixed40x168', 'fixed40x176', 'fixed40x184', 'fixed40x192', 'fixed40x200', 'fixed40x208', 'fixed40x216', 'fixed48x8', 'fixed48x16', 'fixed48x24', 'fixed48x32', 'fixed48x40', 'fixed48x48', 'fixed48x56', 'fixed48x64', 'fixed48x72', 'fixed48x80', 'fixed48x88', 'fixed48x96', 'fixed48x104', 'fixed48x112', 'fixed48x120', 'fixed48x128', 'fixed48x136', 'fixed48x144', 'fixed48x152', 'fixed48x160', 'fixed48x168', 'fixed48x176', 'fixed48x184', 'fixed48x192', 'fixed48x200', 'fixed48x208', 'fixed56x8', 'fixed56x16', 'fixed56x24', 'fixed56x32', 'fixed56x40', 'fixed56x48', 'fixed56x56', 'fixed56x64', 'fixed56x72', 'fixed56x80', 'fixed56x88', 'fixed56x96', 'fixed56x104', 'fixed56x112', 'fixed56x120', 'fixed56x128', 'fixed56x136', 'fixed56x144', 'fixed56x152', 'fixed56x160', 'fixed56x168', 'fixed56x176', 'fixed56x184', 'fixed56x192', 'fixed56x200', 'fixed64x8', 'fixed64x16', 'fixed64x24', 'fixed64x32', 'fixed64x40', 'fixed64x48', 'fixed64x56', 'fixed64x64', 'fixed64x72', 'fixed64x80', 'fixed64x88', 'fixed64x96', 'fixed64x104', 'fixed64x112', 'fixed64x120', 'fixed64x128', 'fixed64x136', 'fixed64x144', 'fixed64x152', 'fixed64x160', 'fixed64x168', 'fixed64x176', 'fixed64x184', 'fixed64x192', 'fixed72x8', 'fixed72x16', 'fixed72x24', 'fixed72x32', 'fixed72x40', 'fixed72x48', 'fixed72x56', 'fixed72x64', 'fixed72x72', 'fixed72x80', 'fixed72x88', 'fixed72x96', 'fixed72x104', 'fixed72x112', 'fixed72x120', 'fixed72x128', 'fixed72x136', 'fixed72x144', 'fixed72x152', 'fixed72x160', 'fixed72x168', 'fixed72x176', 'fixed72x184', 'fixed80x8', 'fixed80x16', 'fixed80x24', 'fixed80x32', 'fixed80x40', 'fixed80x48', 'fixed80x56', 'fixed80x64', 'fixed80x72', 'fixed80x80', 'fixed80x88', 'fixed80x96', 'fixed80x104', 'fixed80x112', 'fixed80x120', 'fixed80x128', 'fixed80x136', 'fixed80x144', 'fixed80x152', 'fixed80x160', 'fixed80x168', 'fixed80x176', 'fixed88x8', 'fixed88x16', 'fixed88x24', 'fixed88x32', 'fixed88x40', 'fixed88x48', 'fixed88x56', 'fixed88x64', 'fixed88x72', 'fixed88x80', 'fixed88x88', 'fixed88x96', 'fixed88x104', 'fixed88x112', 'fixed88x120', 'fixed88x128', 'fixed88x136', 'fixed88x144', 'fixed88x152', 'fixed88x160', 'fixed88x168', 'fixed96x8', 'fixed96x16', 'fixed96x24', 'fixed96x32', 'fixed96x40', 'fixed96x48', 'fixed96x56', 'fixed96x64', 'fixed96x72', 'fixed96x80', 'fixed96x88', 'fixed96x96', 'fixed96x104', 'fixed96x112', 'fixed96x120', 'fixed96x128', 'fixed96x136', 'fixed96x144', 'fixed96x152', 'fixed96x160', 'fixed104x8', 'fixed104x16', 'fixed104x24', 'fixed104x32', 'fixed104x40', 'fixed104x48', 'fixed104x56', 'fixed104x64', 'fixed104x72', 'fixed104x80', 'fixed104x88', 'fixed104x96', 'fixed104x104', 'fixed104x112', 'fixed104x120', 'fixed104x128', 'fixed104x136', 'fixed104x144', 'fixed104x152', 'fixed112x8', 'fixed112x16', 'fixed112x24', 'fixed112x32', 'fixed112x40', 'fixed112x48', 'fixed112x56', 'fixed112x64', 'fixed112x72', 'fixed112x80', 'fixed112x88', 'fixed112x96', 'fixed112x104', 'fixed112x112', 'fixed112x120', 'fixed112x128', 'fixed112x136', 'fixed112x144', 'fixed120x8', 'fixed120x16', 'fixed120x24', 'fixed120x32', 'fixed120x40', 'fixed120x48', 'fixed120x56', 'fixed120x64', 'fixed120x72', 'fixed120x80', 'fixed120x88', 'fixed120x96', 'fixed120x104', 'fixed120x112', 'fixed120x120', 'fixed120x128', 'fixed120x136', 'fixed128x8', 'fixed128x16', 'fixed128x24', 'fixed128x32', 'fixed128x40', 'fixed128x48', 'fixed128x56', 'fixed128x64', 'fixed128x72', 'fixed128x80', 'fixed128x88', 'fixed128x96', 'fixed128x104', 'fixed128x112', 'fixed128x120', 'fixed128x128', 'fixed136x8', 'fixed136x16', 'fixed136x24', 'fixed136x32', 'fixed136x40', 'fixed136x48', 'fixed136x56', 'fixed136x64', 'fixed136x72', 'fixed136x80', 'fixed136x88', 'fixed136x96', 'fixed136x104', 'fixed136x112', 'fixed136x120', 'fixed144x8', 'fixed144x16', 'fixed144x24', 'fixed144x32', 'fixed144x40', 'fixed144x48', 'fixed144x56', 'fixed144x64', 'fixed144x72', 'fixed144x80', 'fixed144x88', 'fixed144x96', 'fixed144x104', 'fixed144x112', 'fixed152x8', 'fixed152x16', 'fixed152x24', 'fixed152x32', 'fixed152x40', 'fixed152x48', 'fixed152x56', 'fixed152x64', 'fixed152x72', 'fixed152x80', 'fixed152x88', 'fixed152x96', 'fixed152x104', 'fixed160x8', 'fixed160x16', 'fixed160x24', 'fixed160x32', 'fixed160x40', 'fixed160x48', 'fixed160x56', 'fixed160x64', 'fixed160x72', 'fixed160x80', 'fixed160x88', 'fixed160x96', 'fixed168x8', 'fixed168x16', 'fixed168x24', 'fixed168x32', 'fixed168x40', 'fixed168x48', 'fixed168x56', 'fixed168x64', 'fixed168x72', 'fixed168x80', 'fixed168x88', 'fixed176x8', 'fixed176x16', 'fixed176x24', 'fixed176x32', 'fixed176x40', 'fixed176x48', 'fixed176x56', 'fixed176x64', 'fixed176x72', 'fixed176x80', 'fixed184x8', 'fixed184x16', 'fixed184x24', 'fixed184x32', 'fixed184x40', 'fixed184x48', 'fixed184x56', 'fixed184x64', 'fixed184x72', 'fixed192x8', 'fixed192x16', 'fixed192x24', 'fixed192x32', 'fixed192x40', 'fixed192x48', 'fixed192x56', 'fixed192x64', 'fixed200x8', 'fixed200x16', 'fixed200x24', 'fixed200x32', 'fixed200x40', 'fixed200x48', 'fixed200x56', 'fixed208x8', 'fixed208x16', 'fixed208x24', 'fixed208x32', 'fixed208x40', 'fixed208x48', 'fixed216x8', 'fixed216x16', 'fixed216x24', 'fixed216x32', 'fixed216x40', 'fixed224x8', 'fixed224x16', 'fixed224x24', 'fixed224x32', 'fixed232x8', 'fixed232x16', 'fixed232x24', 'fixed240x8', 'fixed240x16', 'fixed248x8',
  // All ufixed
  'ufixed', 'ufixed0x8', 'ufixed0x16', 'ufixed0x24', 'ufixed0x32', 'ufixed0x40', 'ufixed0x48', 'ufixed0x56', 'ufixed0x64', 'ufixed0x72', 'ufixed0x80', 'ufixed0x88', 'ufixed0x96', 'ufixed0x104', 'ufixed0x112', 'ufixed0x120', 'ufixed0x128', 'ufixed0x136', 'ufixed0x144', 'ufixed0x152', 'ufixed0x160', 'ufixed0x168', 'ufixed0x176', 'ufixed0x184', 'ufixed0x192', 'ufixed0x200', 'ufixed0x208', 'ufixed0x216', 'ufixed0x224', 'ufixed0x232', 'ufixed0x240', 'ufixed0x248', 'ufixed0x256', 'ufixed8x8', 'ufixed8x16', 'ufixed8x24', 'ufixed8x32', 'ufixed8x40', 'ufixed8x48', 'ufixed8x56', 'ufixed8x64', 'ufixed8x72', 'ufixed8x80', 'ufixed8x88', 'ufixed8x96', 'ufixed8x104', 'ufixed8x112', 'ufixed8x120', 'ufixed8x128', 'ufixed8x136', 'ufixed8x144', 'ufixed8x152', 'ufixed8x160', 'ufixed8x168', 'ufixed8x176', 'ufixed8x184', 'ufixed8x192', 'ufixed8x200', 'ufixed8x208', 'ufixed8x216', 'ufixed8x224', 'ufixed8x232', 'ufixed8x240', 'ufixed8x248', 'ufixed16x8', 'ufixed16x16', 'ufixed16x24', 'ufixed16x32', 'ufixed16x40', 'ufixed16x48', 'ufixed16x56', 'ufixed16x64', 'ufixed16x72', 'ufixed16x80', 'ufixed16x88', 'ufixed16x96', 'ufixed16x104', 'ufixed16x112', 'ufixed16x120', 'ufixed16x128', 'ufixed16x136', 'ufixed16x144', 'ufixed16x152', 'ufixed16x160', 'ufixed16x168', 'ufixed16x176', 'ufixed16x184', 'ufixed16x192', 'ufixed16x200', 'ufixed16x208', 'ufixed16x216', 'ufixed16x224', 'ufixed16x232', 'ufixed16x240', 'ufixed24x8', 'ufixed24x16', 'ufixed24x24', 'ufixed24x32', 'ufixed24x40', 'ufixed24x48', 'ufixed24x56', 'ufixed24x64', 'ufixed24x72', 'ufixed24x80', 'ufixed24x88', 'ufixed24x96', 'ufixed24x104', 'ufixed24x112', 'ufixed24x120', 'ufixed24x128', 'ufixed24x136', 'ufixed24x144', 'ufixed24x152', 'ufixed24x160', 'ufixed24x168', 'ufixed24x176', 'ufixed24x184', 'ufixed24x192', 'ufixed24x200', 'ufixed24x208', 'ufixed24x216', 'ufixed24x224', 'ufixed24x232', 'ufixed32x8', 'ufixed32x16', 'ufixed32x24', 'ufixed32x32', 'ufixed32x40', 'ufixed32x48', 'ufixed32x56', 'ufixed32x64', 'ufixed32x72', 'ufixed32x80', 'ufixed32x88', 'ufixed32x96', 'ufixed32x104', 'ufixed32x112', 'ufixed32x120', 'ufixed32x128', 'ufixed32x136', 'ufixed32x144', 'ufixed32x152', 'ufixed32x160', 'ufixed32x168', 'ufixed32x176', 'ufixed32x184', 'ufixed32x192', 'ufixed32x200', 'ufixed32x208', 'ufixed32x216', 'ufixed32x224', 'ufixed40x8', 'ufixed40x16', 'ufixed40x24', 'ufixed40x32', 'ufixed40x40', 'ufixed40x48', 'ufixed40x56', 'ufixed40x64', 'ufixed40x72', 'ufixed40x80', 'ufixed40x88', 'ufixed40x96', 'ufixed40x104', 'ufixed40x112', 'ufixed40x120', 'ufixed40x128', 'ufixed40x136', 'ufixed40x144', 'ufixed40x152', 'ufixed40x160', 'ufixed40x168', 'ufixed40x176', 'ufixed40x184', 'ufixed40x192', 'ufixed40x200', 'ufixed40x208', 'ufixed40x216', 'ufixed48x8', 'ufixed48x16', 'ufixed48x24', 'ufixed48x32', 'ufixed48x40', 'ufixed48x48', 'ufixed48x56', 'ufixed48x64', 'ufixed48x72', 'ufixed48x80', 'ufixed48x88', 'ufixed48x96', 'ufixed48x104', 'ufixed48x112', 'ufixed48x120', 'ufixed48x128', 'ufixed48x136', 'ufixed48x144', 'ufixed48x152', 'ufixed48x160', 'ufixed48x168', 'ufixed48x176', 'ufixed48x184', 'ufixed48x192', 'ufixed48x200', 'ufixed48x208', 'ufixed56x8', 'ufixed56x16', 'ufixed56x24', 'ufixed56x32', 'ufixed56x40', 'ufixed56x48', 'ufixed56x56', 'ufixed56x64', 'ufixed56x72', 'ufixed56x80', 'ufixed56x88', 'ufixed56x96', 'ufixed56x104', 'ufixed56x112', 'ufixed56x120', 'ufixed56x128', 'ufixed56x136', 'ufixed56x144', 'ufixed56x152', 'ufixed56x160', 'ufixed56x168', 'ufixed56x176', 'ufixed56x184', 'ufixed56x192', 'ufixed56x200', 'ufixed64x8', 'ufixed64x16', 'ufixed64x24', 'ufixed64x32', 'ufixed64x40', 'ufixed64x48', 'ufixed64x56', 'ufixed64x64', 'ufixed64x72', 'ufixed64x80', 'ufixed64x88', 'ufixed64x96', 'ufixed64x104', 'ufixed64x112', 'ufixed64x120', 'ufixed64x128', 'ufixed64x136', 'ufixed64x144', 'ufixed64x152', 'ufixed64x160', 'ufixed64x168', 'ufixed64x176', 'ufixed64x184', 'ufixed64x192', 'ufixed72x8', 'ufixed72x16', 'ufixed72x24', 'ufixed72x32', 'ufixed72x40', 'ufixed72x48', 'ufixed72x56', 'ufixed72x64', 'ufixed72x72', 'ufixed72x80', 'ufixed72x88', 'ufixed72x96', 'ufixed72x104', 'ufixed72x112', 'ufixed72x120', 'ufixed72x128', 'ufixed72x136', 'ufixed72x144', 'ufixed72x152', 'ufixed72x160', 'ufixed72x168', 'ufixed72x176', 'ufixed72x184', 'ufixed80x8', 'ufixed80x16', 'ufixed80x24', 'ufixed80x32', 'ufixed80x40', 'ufixed80x48', 'ufixed80x56', 'ufixed80x64', 'ufixed80x72', 'ufixed80x80', 'ufixed80x88', 'ufixed80x96', 'ufixed80x104', 'ufixed80x112', 'ufixed80x120', 'ufixed80x128', 'ufixed80x136', 'ufixed80x144', 'ufixed80x152', 'ufixed80x160', 'ufixed80x168', 'ufixed80x176', 'ufixed88x8', 'ufixed88x16', 'ufixed88x24', 'ufixed88x32', 'ufixed88x40', 'ufixed88x48', 'ufixed88x56', 'ufixed88x64', 'ufixed88x72', 'ufixed88x80', 'ufixed88x88', 'ufixed88x96', 'ufixed88x104', 'ufixed88x112', 'ufixed88x120', 'ufixed88x128', 'ufixed88x136', 'ufixed88x144', 'ufixed88x152', 'ufixed88x160', 'ufixed88x168', 'ufixed96x8', 'ufixed96x16', 'ufixed96x24', 'ufixed96x32', 'ufixed96x40', 'ufixed96x48', 'ufixed96x56', 'ufixed96x64', 'ufixed96x72', 'ufixed96x80', 'ufixed96x88', 'ufixed96x96', 'ufixed96x104', 'ufixed96x112', 'ufixed96x120', 'ufixed96x128', 'ufixed96x136', 'ufixed96x144', 'ufixed96x152', 'ufixed96x160', 'ufixed104x8', 'ufixed104x16', 'ufixed104x24', 'ufixed104x32', 'ufixed104x40', 'ufixed104x48', 'ufixed104x56', 'ufixed104x64', 'ufixed104x72', 'ufixed104x80', 'ufixed104x88', 'ufixed104x96', 'ufixed104x104', 'ufixed104x112', 'ufixed104x120', 'ufixed104x128', 'ufixed104x136', 'ufixed104x144', 'ufixed104x152', 'ufixed112x8', 'ufixed112x16', 'ufixed112x24', 'ufixed112x32', 'ufixed112x40', 'ufixed112x48', 'ufixed112x56', 'ufixed112x64', 'ufixed112x72', 'ufixed112x80', 'ufixed112x88', 'ufixed112x96', 'ufixed112x104', 'ufixed112x112', 'ufixed112x120', 'ufixed112x128', 'ufixed112x136', 'ufixed112x144', 'ufixed120x8', 'ufixed120x16', 'ufixed120x24', 'ufixed120x32', 'ufixed120x40', 'ufixed120x48', 'ufixed120x56', 'ufixed120x64', 'ufixed120x72', 'ufixed120x80', 'ufixed120x88', 'ufixed120x96', 'ufixed120x104', 'ufixed120x112', 'ufixed120x120', 'ufixed120x128', 'ufixed120x136', 'ufixed128x8', 'ufixed128x16', 'ufixed128x24', 'ufixed128x32', 'ufixed128x40', 'ufixed128x48', 'ufixed128x56', 'ufixed128x64', 'ufixed128x72', 'ufixed128x80', 'ufixed128x88', 'ufixed128x96', 'ufixed128x104', 'ufixed128x112', 'ufixed128x120', 'ufixed128x128', 'ufixed136x8', 'ufixed136x16', 'ufixed136x24', 'ufixed136x32', 'ufixed136x40', 'ufixed136x48', 'ufixed136x56', 'ufixed136x64', 'ufixed136x72', 'ufixed136x80', 'ufixed136x88', 'ufixed136x96', 'ufixed136x104', 'ufixed136x112', 'ufixed136x120', 'ufixed144x8', 'ufixed144x16', 'ufixed144x24', 'ufixed144x32', 'ufixed144x40', 'ufixed144x48', 'ufixed144x56', 'ufixed144x64', 'ufixed144x72', 'ufixed144x80', 'ufixed144x88', 'ufixed144x96', 'ufixed144x104', 'ufixed144x112', 'ufixed152x8', 'ufixed152x16', 'ufixed152x24', 'ufixed152x32', 'ufixed152x40', 'ufixed152x48', 'ufixed152x56', 'ufixed152x64', 'ufixed152x72', 'ufixed152x80', 'ufixed152x88', 'ufixed152x96', 'ufixed152x104', 'ufixed160x8', 'ufixed160x16', 'ufixed160x24', 'ufixed160x32', 'ufixed160x40', 'ufixed160x48', 'ufixed160x56', 'ufixed160x64', 'ufixed160x72', 'ufixed160x80', 'ufixed160x88', 'ufixed160x96', 'ufixed168x8', 'ufixed168x16', 'ufixed168x24', 'ufixed168x32', 'ufixed168x40', 'ufixed168x48', 'ufixed168x56', 'ufixed168x64', 'ufixed168x72', 'ufixed168x80', 'ufixed168x88', 'ufixed176x8', 'ufixed176x16', 'ufixed176x24', 'ufixed176x32', 'ufixed176x40', 'ufixed176x48', 'ufixed176x56', 'ufixed176x64', 'ufixed176x72', 'ufixed176x80', 'ufixed184x8', 'ufixed184x16', 'ufixed184x24', 'ufixed184x32', 'ufixed184x40', 'ufixed184x48', 'ufixed184x56', 'ufixed184x64', 'ufixed184x72', 'ufixed192x8', 'ufixed192x16', 'ufixed192x24', 'ufixed192x32', 'ufixed192x40', 'ufixed192x48', 'ufixed192x56', 'ufixed192x64', 'ufixed200x8', 'ufixed200x16', 'ufixed200x24', 'ufixed200x32', 'ufixed200x40', 'ufixed200x48', 'ufixed200x56', 'ufixed208x8', 'ufixed208x16', 'ufixed208x24', 'ufixed208x32', 'ufixed208x40', 'ufixed208x48', 'ufixed216x8', 'ufixed216x16', 'ufixed216x24', 'ufixed216x32', 'ufixed216x40', 'ufixed224x8', 'ufixed224x16', 'ufixed224x24', 'ufixed224x32', 'ufixed232x8', 'ufixed232x16', 'ufixed232x24', 'ufixed240x8', 'ufixed240x16', 'ufixed248x8', 'event', 'emit', 'enum', 'let', 'mapping', 'private', 'public', 'external', 'internal', 'indexed', 'anonymous', 'view', 'pure', 'inherited', 'storage', 'memory', 'virtual', 'calldata', 'override', 'abstract', 'payable', 'nonpayable', 'constants', 'immutable', 'assert', 'require', 'revert', 'blockhash', 'keccak256', 'sha256', 'ripemd160', 'ecrecover', 'addmod', 'mulmod', 'selfdestruct', 'type', 'gasleft', 'abi', 'block', 'bytes', 'msg', 'tx', 'Error', 'Panic', 'exceptions', 'true', 'false', 'var', 'import', 'constant', 'fallback', 'receive', 'if', 'else', 'for', 'while', 'do', 'break', 'continue', 'throw', 'returns', 'return', 'suicide', 'new', 'is', 'this', 'super', 'try', 'catch'],
  operators: ['=', '>', '<', '!', '~', '?', ':', '==', '<=', '>=', '!=', '&&', '||', '++', '--', '+', '-', '*', '/', '&', '|', '^', '%', '<<', '>>', '>>>', '+=', '-=', '*=', '/=', '&=', '|=', '^=', '%=', '<<=', '>>=', '>>>='],
  // we include these common regular expressions
  symbols: /[=><!~?:&|+\-*\/\^%]+/,
  escapes: /\\(?:[abfnrtv\\"']|x[0-9A-Fa-f]{1,4}|u[0-9A-Fa-f]{4}|U[0-9A-Fa-f]{8})/,
  integersuffix: /(ll|LL|u|U|l|L)?(ll|LL|u|U|l|L)?/,
  floatsuffix: /[fFlL]?/,
  // The main tokenizer for our languages
  tokenizer: {
    root: [
    // identifiers and keywords
    [/[a-zA-Z_]\w*/, {
      cases: {
        '@keywords': {
          token: 'keyword.$0'
        },
        '@default': 'identifier'
      }
    }],
    // whitespace
    {
      include: '@whitespace'
    },
    // [[ attributes ]].
    [/\[\[.*\]\]/, 'annotation'],
    // Preprocessor directive
    [/^\s*#\w+/, 'keyword'],
    // DataTypes
    [/int\d*/, 'keyword'],
    // delimiters and operators
    [/[{}()\[\]]/, '@brackets'], [/[<>](?!@symbols)/, '@brackets'], [/@symbols/, {
      cases: {
        '@operators': 'delimiter',
        '@default': ''
      }
    }],
    // numbers
    [/\d*\d+[eE]([\-+]?\d+)?(@floatsuffix)/, 'number.float'], [/\d*\.\d+([eE][\-+]?\d+)?(@floatsuffix)/, 'number.float'], [/0[xX][0-9a-fA-F']*[0-9a-fA-F](@integersuffix)/, 'number.hex'], [/0[0-7']*[0-7](@integersuffix)/, 'number.octal'], [/0[bB][0-1']*[0-1](@integersuffix)/, 'number.binary'], [/\d[\d']*\d(@integersuffix)/, 'number'], [/\d(@integersuffix)/, 'number'],
    // delimiter: after number because of .\d floats
    [/[;,.]/, 'delimiter'],
    // strings
    [/"([^"\\]|\\.)*$/, 'string.invalid'], [/"/, 'string', '@string'],
    // characters
    [/'[^\\']'/, 'string'], [/(')(@escapes)(')/, ['string', 'string.escape', 'string']], [/'/, 'string.invalid']],
    whitespace: [[/[ \t\r\n]+/, ''], [/\/\*\*(?!\/)/, 'comment.doc', '@doccomment'], [/\/\*/, 'comment', '@comment'], [/\/\/.*$/, 'comment']],
    comment: [[/[^\/*]+/, 'comment'], [/\*\//, 'comment', '@pop'], [/[\/*]/, 'comment']],
    // Identical copy of comment above, except for the addition of .doc
    doccomment: [[/[^\/*]+/, 'comment.doc'], [/\*\//, 'comment.doc', '@pop'], [/[\/*]/, 'comment.doc']],
    string: [[/[^\\"]+/, 'string'], [/@escapes/, 'string.escape'], [/\\./, 'string.escape.invalid'], [/"/, 'string', '@pop']]
  }
};

function initTheme(monaco) {
  monaco.editor.defineTheme('myCustomTheme', {
    base: 'vs-dark',
    inherit: true,
    colors: {},
    rules: []
  });
  monaco.editor.setTheme('myCustomTheme');
}
function initModels(monaco, editor, modelInfos, dispatch, overWriteExisting) {
  if (overWriteExisting === void 0) {
    overWriteExisting = false;
  }
  addModels(monaco, editor, 0, modelInfos, [], dispatch, overWriteExisting);
}
// this state link to the editor state
function registerLangs(monaco, state) {
  // Register a new language
  monaco.languages.register({
    id: SupportLanguage.Solidity
  });
  // Register a tokens provider for the language
  monaco.languages.setMonarchTokensProvider(SupportLanguage.Solidity, solidityTokensProvider);
  monaco.languages.setLanguageConfiguration(SupportLanguage.Solidity, solidityLanguageConfig);
  monaco.languages.registerDefinitionProvider(SupportLanguage.Solidity, new DefinitionProvider(monaco, state));
  registerFileCompletion(monaco);
  registerFileImports(monaco, state);
}
function registerCommandsAndActions(monaco, editor) {
  // save
  editor.addCommand(monaco.KeyMod.CtrlCmd | monaco.KeyCode.KeyS, function () {
    // save
    editor.saveViewState();
    // editor.getAction('editor.action.formatDocument').run();
  });
  // add context menu items
  var zoominAction = {
    id: "zoomIn",
    label: "Zoom In",
    contextMenuOrder: 0,
    contextMenuGroupId: "zooming",
    keybindings: [
    // eslint-disable-next-line no-bitwise
    monaco.KeyMod.CtrlCmd | monaco.KeyCode.Equal],
    run: function run() {
      editor.updateOptions({
        fontSize: Number(editor.getOption(46)) + 1
      });
    }
  };
  var zoomOutAction = {
    id: "zoomOut",
    label: "Zoom Out",
    contextMenuOrder: 0,
    contextMenuGroupId: "zooming",
    keybindings: [
    // eslint-disable-next-line no-bitwise
    monaco.KeyMod.CtrlCmd | monaco.KeyCode.Minus],
    run: function run() {
      editor.updateOptions({
        fontSize: Number(editor.getOption(46)) - 1
      });
    }
  };
  editor.addAction(zoomOutAction);
  editor.addAction(zoominAction);
  // @ts-ignore
  var editorService = editor._codeEditorService;
  var openEditorBase = editorService.openCodeEditor.bind(editorService);
  editorService.openCodeEditor = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(input, source) {
      var result;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return openEditorBase(input, source);
          case 2:
            result = _context.sent;
            if (input && input.resource && input.resource.path) {
              try {
                if (input.options && input.options.selection) {
                  editor.revealRange(input.options.selection);
                  editor.setPosition({
                    column: input.options.selection.startColumn,
                    lineNumber: input.options.selection.startLineNumber
                  });
                }
              } catch (e) {
                console.log(e);
              }
            }
            return _context.abrupt("return", result);
          case 5:
          case "end":
            return _context.stop();
        }
      }, _callee);
    }));
    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
}
function registerFileCompletion(monaco) {
  monaco.languages.registerCompletionItemProvider(SupportLanguage.Solidity, {
    provideCompletionItems: function provideCompletionItems(model, position) {
      var textUntilPosition = model.getValueInRange({
        startLineNumber: position.lineNumber,
        startColumn: 1,
        endLineNumber: position.lineNumber,
        endColumn: position.column
      });
      var word = model.getWordUntilPosition(position);
      var range = {
        startLineNumber: position.lineNumber,
        endLineNumber: position.lineNumber,
        startColumn: word.startColumn,
        endColumn: word.endColumn
      };
      var suggestions = [].concat(solidityTokensProvider.keywords.map(function (k) {
        return {
          label: k,
          kind: monaco.languages.CompletionItemKind.Keyword,
          insertText: k,
          range: range
        };
      }));
      return {
        suggestions: suggestions
      };
    }
  });
}
function registerFileImports(monaco, state) {
  monaco.languages.registerCompletionItemProvider(SupportLanguage.Solidity, {
    triggerCharacters: ["'", '"'],
    provideCompletionItems: function provideCompletionItems(model, position) {
      var textUntilPosition = model.getValueInRange({
        startLineNumber: 1,
        startColumn: 1,
        endLineNumber: position.lineNumber,
        endColumn: position.column
      });
      var match = textUntilPosition.match(/import\s+/);
      if (!match) {
        return {
          suggestions: []
        };
      }
      var word = model.getWordUntilPosition(position);
      var range = {
        startLineNumber: position.lineNumber,
        endLineNumber: position.lineNumber,
        startColumn: word.startColumn,
        endColumn: word.endColumn
      };
      var suggestions = state.models.filter(function (m) {
        return m.filename !== state.models[state.modelIndex].filename;
      }).map(function (m) {
        return {
          label: m.filename,
          kind: monaco.languages.CompletionItemKind.File,
          insertText: m.filename,
          range: range
        };
      });
      return {
        suggestions: suggestions
      };
    }
  });
}
function registerListeners(editor, editorApi, editorState) {
  var transformCompileError = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(data) {
      var models, modelIndex, curFile, curFileContent, sources, output, allErrors, _iterator, _step, error, errorMarker, lineBreaks, lineColumn, filePath, importFilePositions, _iterator2, _step2, importFilePosition, _iterator3, _step3, line;
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            models = (editorState == null ? void 0 : editorState.models) || [];
            modelIndex = (editorState == null ? void 0 : editorState.modelIndex) || 0;
            curFile = models[modelIndex].filename;
            curFileContent = models[modelIndex].value;
            sources = data.input.sources || {};
            output = data.output || {};
            allErrors = [];
            if (!(output.error || output.errors)) {
              _context2.next = 33;
              break;
            }
            if (!output.error) {
              _context2.next = 11;
              break;
            }
            _context2.next = 32;
            break;
          case 11:
            _iterator = _createForOfIteratorHelperLoose(output.errors);
          case 12:
            if ((_step = _iterator()).done) {
              _context2.next = 32;
              break;
            }
            error = _step.value;
            if (error.sourceLocation) {
              _context2.next = 19;
              break;
            }
            errorMarker = createErrorMarker(error, curFile, {
              start: {
                line: 0,
                column: 0
              },
              end: {
                line: 0,
                column: 100
              }
            });
            allErrors = [].concat(allErrors, [errorMarker]);
            _context2.next = 30;
            break;
          case 19:
            lineBreaks = getLinebreakPositions(sources[error.sourceLocation.file].content);
            lineColumn = convertOffsetToLineColumn({
              start: error.sourceLocation.start,
              length: error.sourceLocation.end - error.sourceLocation.start
            }, lineBreaks);
            filePath = error.sourceLocation.file;
            if (!(filePath !== curFile)) {
              _context2.next = 29;
              break;
            }
            _context2.next = 25;
            return getPositionForImportErrors(filePath, curFileContent);
          case 25:
            importFilePositions = _context2.sent;
            for (_iterator2 = _createForOfIteratorHelperLoose(importFilePositions); !(_step2 = _iterator2()).done;) {
              importFilePosition = _step2.value;
              for (_iterator3 = _createForOfIteratorHelperLoose(importFilePosition.lines); !(_step3 = _iterator3()).done;) {
                line = _step3.value;
                allErrors = [].concat(allErrors, [createErrorMarker(error, curFile, line.position)]);
              }
            }
            _context2.next = 30;
            break;
          case 29:
            allErrors = [].concat(allErrors, [createErrorMarker(error, filePath, lineColumn)]);
          case 30:
            _context2.next = 12;
            break;
          case 32:
            editorApi.addErrorMarker(allErrors);
          case 33:
          case "end":
            return _context2.stop();
        }
      }, _callee2);
    }));
    return function transformCompileError(_x3) {
      return _ref2.apply(this, arguments);
    };
  }();
  var registerListenErrorMarkers = function registerListenErrorMarkers() {
    editor.onDidChangeModelContent(function (e) {
      editorState.codeParser.compilerService.compile().then(function (data) {
        return transformCompileError(data);
      });
    });
    editor.onDidChangeModel(function (e) {
      editorState.codeParser.compilerService.compile().then(function (data) {
        return transformCompileError(data);
      });
    });
  };
  registerListenErrorMarkers();
}
function addModels(monaco, editor, modelIndex, modelInfos, currentModels, dispatch, overWriteExisting) {
  if (overWriteExisting === void 0) {
    overWriteExisting = false;
  }
  var formatModels = [];
  for (var _iterator4 = _createForOfIteratorHelperLoose(modelInfos), _step4; !(_step4 = _iterator4()).done;) {
    var modelInfo = _step4.value;
    var model = monaco.editor.getModel(monaco.Uri.file(modelInfo.filename));
    //If model not exist create, otherwise replace value (for editor resets).
    if (model === null) {
      model = monaco.editor.createModel(modelInfo.value, modelInfo.language, monaco.Uri.file(modelInfo.filename));
      monaco.editor.setModelLanguage(model, modelInfo.language);
    } else if (overWriteExisting) {
      model.setValue(modelInfo.value);
    }
    model.updateOptions({
      tabSize: 2
    });
    formatModels.push(_extends({}, modelInfo, {
      model: model
    }));
  }
  //undefined initially so ternary operator deals with edge case, useContext typing issue
  dispatch({
    type: 'updateModels',
    payload: {
      models: [].concat(currentModels, formatModels)
    }
  });
  var firstModelInfo = modelInfos[0];
  var firstModel = formatModels[0];
  //The last model with initial true should be initial
  if (!firstModelInfo.notInitial) {
    editor.setModel(firstModel.model);
    dispatch({
      type: 'updateModelIndex',
      payload: {
        modelIndex: modelIndex
      }
    });
  }
}
function getCursorPosition(monaco, state, offset) {
  var _models$index;
  if (offset === void 0) {
    offset = true;
  }
  if (!monaco) return;
  var models = (state == null ? void 0 : state.models) || [];
  var index = (state == null ? void 0 : state.modelIndex) || 0;
  var model = (_models$index = models[index]) == null ? void 0 : _models$index.model;
  if (model) {
    var _state$editor, _state$editor2;
    return offset ? model.getOffsetAt((_state$editor = state.editor) == null ? void 0 : _state$editor.getPosition()) : (_state$editor2 = state.editor) == null ? void 0 : _state$editor2.getPosition();
  }
  return;
}

function PlayButton(_ref) {
  var _useEditor = useEditor(),
    state = _useEditor.state,
    dispatch = _useEditor.dispatch;
  var monaco = useMemo(function () {
    return state.monaco;
  }, [state.monaco]);
  var editor = useMemo(function () {
    return state.editor;
  }, [state.editor]);
  var models = useMemo(function () {
    return state.models;
  }, [state.models]);
  var setConsoleMessages = useCallback(function (consoleMessages) {
    return dispatch({
      type: 'updateConsoleMessages',
      payload: {
        consoleMessages: consoleMessages
      }
    });
  }, [dispatch]);
  var run = function run() {
    console.log(getCursorPosition(monaco, state));
  };
  return React.createElement("div", {
    style: {
      display: 'flex',
      marginLeft: 'auto',
      marginRight: '3px'
    }
  }, React.createElement(PlayArrowIcon, {
    onClick: run,
    style: {
      color: '#09ad11'
    }
  }));
}

var useStyles = /*#__PURE__*/makeStyles({
  JS: {
    height: '100%',
    marginRight: '5px',
    color: '#cbcb41',
    fontSize: '0.7em',
    fontWeight: 700
  },
  SOL: {
    height: '100%',
    marginRight: '5px',
    color: '#5098b7',
    fontSize: '0.7em',
    fontWeight: 700
  },
  JSON: {
    height: '100%',
    marginRight: '5px',
    color: '#c7c741',
    fontSize: '0.8em',
    fontWeight: 700
  }
});
function LanguageIcon(_ref) {
  var language = _ref.language;
  var classes = useStyles();
  if (language === SupportLanguage.Solidity) {
    return React.createElement("span", {
      className: classes.SOL
    }, "SOL");
  }
  return null;
}

var useStyles$1 = /*#__PURE__*/makeStyles$1({
  tab: {
    display: 'inline-flex',
    height: '100%',
    cursor: 'pointer',
    alignItems: 'center',
    color: '#919191',
    padding: '0.3rem 0.4rem 0.3rem 0.6rem !important',
    fontSize: '0.75rem',
    fontWeight: 400,
    borderRight: '1px solid #252526',
    backgroundColor: '#2d3233',
    '&:hover': {
      '& span:last-child': {
        visibility: 'visible',
        fontSize: '0.9rem',
        marginLeft: '5px',
        color: 'gainsboro'
      }
    },
    '& span:last-child': {
      visibility: 'hidden',
      fontSize: '0.9rem',
      marginLeft: '5px',
      color: 'gainsboro'
    }
  }
});
function Tab(_ref) {
  var model = _ref.model,
    index = _ref.index,
    dragTabMove = _ref.dragTabMove,
    deleteTab = _ref.deleteTab;
  var classes = useStyles$1();
  var _useEditor = useEditor(),
    state = _useEditor.state,
    dispatch = _useEditor.dispatch;
  var _useDrag = useDrag({
      item: {
        type: 'moveIdx',
        index: index
      },
      collect: function collect(monitor) {
        return {
          isDragging: !!monitor.isDragging()
        };
      }
    }),
    drag = _useDrag[1];
  var _useDrop = useDrop({
      accept: 'moveIdx',
      drop: function drop(item) {
        dragTabMove(item.index, index);
      },
      collect: function collect(monitor) {
        return {
          isOver: !!monitor.isOver()
        };
      }
    }),
    isOver = _useDrop[0].isOver,
    drop = _useDrop[1];
  return React.createElement("span", {
    ref: drag
  }, React.createElement("span", {
    onMouseDown: function onMouseDown() {
      var _state$editor;
      dispatch({
        type: "updateModelIndex",
        payload: {
          modelIndex: index
        }
      });
      (_state$editor = state.editor) == null ? void 0 : _state$editor.setModel(model.model);
    },
    className: classes.tab,
    key: index,
    ref: drop,
    style: {
      backgroundColor: state.modelIndex === index ? '#1D2021' : isOver ? '#4F4F4F' : '#2d3233'
    }
  }, React.createElement(LanguageIcon, {
    language: model.language
  }), React.createElement("span", null, model.model.uri.path.substring(1)), React.createElement("span", {
    onClick: function onClick() {
      return deleteTab(index);
    }
  }, "x")));
}

var useStyles$2 = /*#__PURE__*/makeStyles$1({
  dropdown: {
    position: 'relative',
    display: 'inline-block'
  },
  dropdownContent: {
    display: 'flex',
    position: 'absolute',
    backgroundColor: '#252526',
    border: '1px solid #007fd4',
    minWidth: '160px',
    zIndex: 1,
    margin: '3px'
  },
  dropdownInput: {
    border: 0,
    color: '#b0b0b0',
    backgroundColor: '#2d3233',
    outline: 'none !important'
  },
  dropdownSelect: {
    border: '0px',
    borderLeft: '1px solid #007fd4',
    color: '#b0b0b0',
    backgroundColor: '#2d3233',
    outline: 'none !important'
  }
});
var AddIcon = /*#__PURE__*/styled(AddIconComponent)(function () {
  return {
    color: '#787777'
  };
});
function NewFileButton(_ref) {
  var plusModel = _ref.plusModel;
  var classes = useStyles$2();
  var _useState = useState(false),
    openMenu = _useState[0],
    setOpenMenu = _useState[1];
  var _useState2 = useState(''),
    input = _useState2[0],
    setInput = _useState2[1];
  var _useState3 = useState(SupportLanguage.Solidity),
    fileType = _useState3[0],
    setFileType = _useState3[1];
  var ref = useOnclickOutside(function () {
    setOpenMenu(false);
  });
  var createModelOnEnter = function createModelOnEnter() {
    var extension = fileType === SupportLanguage.Solidity ? '.sol' : '.js';
    plusModel(input + extension, fileType);
  };
  return React.createElement("div", {
    className: classes.dropdown,
    ref: ref
  }, React.createElement(IconButton, {
    size: "small",
    onClick: function onClick() {
      return setOpenMenu(true);
    }
  }, React.createElement(AddIcon, null)), openMenu && React.createElement("div", {
    className: classes.dropdownContent
  }, React.createElement("input", {
    className: classes.dropdownInput,
    autoFocus: true,
    placeholder: "type file name, press enter",
    onChange: function onChange(e) {
      return setInput(e.target.value);
    },
    onKeyDown: function onKeyDown(e) {
      if (e.key === 'Enter') {
        createModelOnEnter();
        setOpenMenu(false);
      }
    }
  }), React.createElement("select", {
    className: classes.dropdownSelect,
    onChange: function onChange(e) {
      return setFileType(e.target.value);
    },
    onKeyDown: function onKeyDown(e) {
      if (e.key === 'Enter') {
        createModelOnEnter();
        setOpenMenu(false);
      }
    }
  }, React.createElement("option", {
    value: SupportLanguage.Solidity
  }, ".sol"))));
}

var useStyles$3 = /*#__PURE__*/makeStyles$1({
  bar: {
    display: 'flex',
    flexDirection: 'row',
    flexGrow: 1,
    height: '33px',
    backgroundColor: '#2d3233',
    width: '100%',
    alignItems: 'center'
  }
});
function TopBar(_ref) {
  var modelInfos = _ref.modelInfos;
  var classes = useStyles$3();
  var _useEditor = useEditor(),
    state = _useEditor.state,
    dispatch = _useEditor.dispatch;
  var models = useMemo(function () {
    return state.models || [];
  }, [state.models]);
  var editor = useMemo(function () {
    return state.editor;
  }, [state.editor]);
  var monaco = useMemo(function () {
    return state.monaco;
  }, [state.monaco]);
  var selectedIdx = useMemo(function () {
    return state.modelIndex;
  }, [state.modelIndex]);
  // curry function adding from mount
  var plusModel = function plusModel(filename, language) {
    addModels(monaco, editor, state.models.length, [new ModelInfoType({
      filename: filename,
      language: language
    })], state.models, dispatch);
  };
  function dragTabMove(draggedIdx, draggedToIdx) {
    if (models) {
      var newModels = [].concat(models);
      // drag left
      if (draggedIdx > draggedToIdx) {
        newModels.splice(draggedToIdx, 0, models[draggedIdx]);
        newModels.splice(draggedIdx + 1, 1);
      } else {
        // drag right
        newModels.splice(draggedToIdx + 1, 0, models[draggedIdx]);
        newModels.splice(draggedIdx, 1);
      }
      dispatch({
        type: 'updateModels',
        payload: {
          models: newModels
        }
      });
      dispatch({
        type: "updateModelIndex",
        payload: {
          modelIndex: draggedToIdx
        }
      });
    }
  }
  function deleteTab(index) {
    if (models && models.length > 1) {
      var newModels = [].concat(models);
      newModels.splice(index, 1);
      dispatch({
        type: 'updateModels',
        payload: {
          models: newModels
        }
      });
      if (index < newModels.length) {
        dispatch({
          type: "updateModelIndex",
          payload: {
            modelIndex: index
          }
        });
        editor == null ? void 0 : editor.setModel(newModels[index].model);
      } else {
        dispatch({
          type: "updateModelIndex",
          payload: {
            modelIndex: index
          }
        });
        editor == null ? void 0 : editor.setModel(newModels[index - 1].model);
      }
    } else {
      console.error("Cannot delete only model");
    }
  }
  // if model is readonly make editor readonly
  // Since this code could go anywhere should I extract a custom hook?
  useEffect(function () {
    if (editor && models && selectedIdx !== undefined) {
      var _models$selectedIdx;
      editor.updateOptions({
        readOnly: (_models$selectedIdx = models[selectedIdx]) == null ? void 0 : _models$selectedIdx.readOnly
      });
    }
  }, [selectedIdx, editor, selectedIdx]);
  return React.createElement("div", {
    className: classes.bar
  }, models && models.filter(function (model) {
    return !model.shown;
  }).map(function (model, index) {
    return React.createElement(Tab, {
      key: index,
      model: model,
      index: index,
      dragTabMove: dragTabMove,
      deleteTab: deleteTab
    });
  }), React.createElement(NewFileButton, {
    plusModel: plusModel
  }), React.createElement(PlayButton, {
    modelInfos: modelInfos
  }));
}

function browserSolidityCompiler() {
  var ctx = self;
  ctx.addEventListener('message', function (_ref) {
    var data = _ref.data;
    if (data === 'fetch-compiler-versions') {
      fetch('https://binaries.soliditylang.org/bin/list.json').then(function (response) {
        return response.json();
      }).then(function (result) {
        // @ts-ignore    
        postMessage(result);
      });
    } else {
      // version find in https://github.com/ethereum/solc-bin/tree/gh-pages/bin
      importScripts();
      var soljson = ctx.Module;
      if ('_solidity_compile' in soljson) {
        var compile = soljson.cwrap('solidity_compile', 'string', ['string', 'number']);
        var output = JSON.parse(compile(data.input));
        // @ts-ignore    
        postMessage({
          output: output,
          input: data.input && JSON.parse(data.input)
        });
      }
    }
  });
}
function importScripts(_arg0) {
  throw new Error('Function not implemented.');
}
if (window !== self) {
  browserSolidityCompiler();
}

var solidityCompiler = /*#__PURE__*/function () {
  var _ref2 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(_ref) {
    var version, input, worker;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          version = _ref.version, input = _ref.input;
          worker = new Worker(URL.createObjectURL(new Blob(["(" + browserSolidityCompiler + ")(" + setupMethods + ")"], {
            type: 'module'
          })));
          return _context.abrupt("return", new Promise(function (resolve, reject) {
            worker.postMessage({
              input: JSON.stringify(input),
              version: version
            });
            worker.onmessage = function (_ref3) {
              var data = _ref3.data;
              resolve(data);
            };
            worker.onerror = reject;
          }));
        case 3:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return function solidityCompiler(_x) {
    return _ref2.apply(this, arguments);
  };
}();
var getCompilerVersions = /*#__PURE__*/function () {
  var _ref4 = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2() {
    var worker;
    return _regeneratorRuntime().wrap(function _callee2$(_context2) {
      while (1) switch (_context2.prev = _context2.next) {
        case 0:
          worker = new Worker(URL.createObjectURL(new Blob(["(" + browserSolidityCompiler + ")()"], {
            type: 'module'
          })));
          return _context2.abrupt("return", new Promise(function (resolve, reject) {
            worker.postMessage('fetch-compiler-versions');
            worker.onmessage = function (_ref5) {
              var data = _ref5.data;
              resolve(data);
            };
            worker.onerror = reject;
          }));
        case 2:
        case "end":
          return _context2.stop();
      }
    }, _callee2);
  }));
  return function getCompilerVersions() {
    return _ref4.apply(this, arguments);
  };
}();

var makeCompilerInput = function makeCompilerInput(sources, opts) {
  var baseInput = {
    language: 'Solidity',
    sources: sources,
    settings: {
      optimizer: {
        enabled: opts.optimize === true || opts.optimize === 1,
        runs: opts.runs > -1 ? opts.runs : 200
      },
      libraries: opts.libraries,
      outputSelection: {
        '*': {
          '': ['ast'],
          '*': ['abi', 'metadata', 'devdoc', 'userdoc', 'storageLayout', 'evm.legacyAssembly', 'evm.bytecode', 'evm.deployedBytecode', 'evm.methodIdentifiers', 'evm.gasEstimates', 'evm.assembly']
        }
      }
    }
  };
  if (opts.evmVersion) {
    if (opts.evmVersion.toLowerCase() == 'default') {
      opts.evmVersion = null;
    } else {
      baseInput.settings.evmVersion = opts.evmVersion;
    }
  }
  if (opts.language) {
    baseInput.language = opts.language;
  }
  if (opts.language === 'Yul' && baseInput.settings.optimizer.enabled) {
    if (!baseInput.settings.optimizer.details) {
      baseInput.settings.optimizer.details = {};
    }
    baseInput.settings.optimizer.details.yul = true;
  }
  return baseInput;
};

var CodeParserCompiler = /*#__PURE__*/function () {
  function CodeParserCompiler(editorApi, editorState, parseVersion) {
    this.editorApi = editorApi;
    this.editorState = editorState;
    this.parseVersion = parseVersion;
  }
  var _proto = CodeParserCompiler.prototype;
  _proto.compile = function compile() {
    var _Object$assign;
    var currentModel = this.editorState.models[this.editorState.modelIndex];
    var codeVersion = this.parseVersion.latestVersion;
    try {
      codeVersion = this.parseVersion.resolveCodeVersion(currentModel.model.getValue());
    } catch (error) {}
    var versionUrl = this.parseVersion.getVersionUri(codeVersion);
    var imports = this.resolveImports(currentModel);
    var sources = Object.assign((_Object$assign = {}, _Object$assign[currentModel.filename] = {
      content: currentModel.model.getValue()
    }, _Object$assign), this.resolveSource(imports));
    // wasm compiler use string config
    var compilerConfig = makeCompilerInput(sources, {
      optimize: true,
      runs: 200,
      language: 'Solidity'
    });
    // TODO: Consider partial adoption WebAssembly
    return solidityCompiler({
      version: "https://binaries.soliditylang.org/bin/" + versionUrl,
      input: compilerConfig
    });
  };
  _proto.resolveImports = function resolveImports(model) {
    var code = model.model.getValue();
    var importRegex = /^\s*import\s+["']([^"']+\.(sol))["']/gm;
    var importHints = [];
    var match;
    while ((match = importRegex.exec(code)) !== null) {
      var importFilePath = match[1];
      if (importFilePath.startsWith('./')) {
        var path = /(.*\/).*/.exec(model.filename);
        importFilePath = path ? importFilePath.replace('./', path[1]) : importFilePath.slice(2);
      }
      if (!importHints.includes(importFilePath)) importHints.push(importFilePath);
    }
    return importHints;
  };
  _proto.resolveSource = function resolveSource(imports) {
    var monaco = this.editorState.monaco;
    var find = function find(value) {
      var uri = monaco == null ? void 0 : monaco.Uri.parse(value);
      return monaco == null ? void 0 : monaco.editor.getModels().find(function (model) {
        return model.uri.toString() === (uri == null ? void 0 : uri.toString());
      });
    };
    var sources = {};
    imports.forEach(function (im) {
      if (find(im)) {
        var _Object$assign2;
        Object.assign(sources, (_Object$assign2 = {}, _Object$assign2[im] = {
          content: find(im).getValue()
        }, _Object$assign2));
      }
    });
    return sources;
  };
  return CodeParserCompiler;
}();

var DefaultCacheTime = 1000 * 60 * 60 * 24;
function cache(key, value, ops) {
  var cacheTime = ops.cacheTime || DefaultCacheTime;
  var needCacheValue = {
    value: value,
    expired_time: new Date().getTime() + cacheTime
  };
  localStorage.setItem(key, JSON.stringify(needCacheValue));
}
function getCache(key) {
  var _value;
  var localValueString = localStorage.getItem(key);
  var value;
  if (localValueString) {
    value = JSON.parse(localValueString);
  }
  return {
    value: (_value = value) == null ? void 0 : _value.value,
    expired: value ? value.expired_time < new Date().getTime() : true
  };
}

var COMPILER_INFO_KEY = 'compiler_info';
var ParserVersion = /*#__PURE__*/function () {
  function ParserVersion(editorApi, editorState) {
    this.allVersions = [];
    this.latestVersion = '';
    this.editorApi = editorApi;
    this.editorState = editorState;
  }
  var _proto = ParserVersion.prototype;
  _proto.init = /*#__PURE__*/function () {
    var _init = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return this.getCompilerInfo();
          case 2:
          case "end":
            return _context.stop();
        }
      }, _callee, this);
    }));
    function init() {
      return _init.apply(this, arguments);
    }
    return init;
  }();
  _proto.resolveCodeVersion = function resolveCodeVersion(code) {
    var pattern = /pragma solidity\s+(\^|~)?(\d+\.\d+\.\d+)/;
    var match = pattern.exec(code);
    var version = match[2];
    var symbol = match[1];
    return symbol ? symbol + version : version;
  };
  _proto.getVersionUri = function getVersionUri(version) {
    var _this$compilerInfo;
    var matchVersion = this.matchVersion(version);
    return (_this$compilerInfo = this.compilerInfo) == null ? void 0 : _this$compilerInfo.releases[matchVersion];
  };
  _proto.matchVersion = function matchVersion(version) {
    var bestVersion = semver.maxSatisfying(this.allVersions, version);
    if (!bestVersion) {
      console.warn('No version match, use latest version');
      return this.latestVersion; // This is the latest version
    }

    return bestVersion;
  };
  _proto.getCompilerInfo = /*#__PURE__*/function () {
    var _getCompilerInfo = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2() {
      var _getCache, oldCompilerInfo, expired, curCompiler;
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            _getCache = getCache(COMPILER_INFO_KEY), oldCompilerInfo = _getCache.value, expired = _getCache.expired;
            curCompiler = oldCompilerInfo;
            if (!(!oldCompilerInfo || expired)) {
              _context2.next = 7;
              break;
            }
            _context2.next = 5;
            return getCompilerVersions();
          case 5:
            curCompiler = _context2.sent;
            cache(COMPILER_INFO_KEY, curCompiler, {
              cacheTime: 1000 * 60 * 60 * 24
            });
          case 7:
            this.compilerInfo = curCompiler;
            this.allVersions = Object.keys(curCompiler.releases);
            this.latestVersion = curCompiler.latestRelease;
            return _context2.abrupt("return", curCompiler);
          case 11:
          case "end":
            return _context2.stop();
        }
      }, _callee2, this);
    }));
    function getCompilerInfo() {
      return _getCompilerInfo.apply(this, arguments);
    }
    return getCompilerInfo;
  }();
  _proto.setVersion = function setVersion() {};
  return ParserVersion;
}();

var CodeParser = function CodeParser(editorApi, editorState) {
  this.parseVersion = new ParserVersion(editorApi, editorState);
  this.compilerService = new CodeParserCompiler(editorApi, editorState, this.parseVersion);
};

var findModel = function findModel(models, filePath) {
  // 由于该组件简单处理文件系统，不存在文件夹之类的路径，故：filePath就是filename
  return models.find(function (model) {
    return model.filename === filePath;
  });
};

function App(_ref) {
  var modelInfos = _ref.modelInfos,
    id = _ref.id;
  var _useEditor = useEditor(),
    stateRef = _useEditor.stateRef,
    dispatch = _useEditor.dispatch,
    actions = _useEditor.actions;
  var editorRef = useRef();
  var monacoRef = useRef();
  var editorApiRef = useRef({});
  function handleEditorDidMount(_x, _x2) {
    return _handleEditorDidMount.apply(this, arguments);
  }
  function _handleEditorDidMount() {
    _handleEditorDidMount = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(editor, monaco) {
      var codeParser;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            editorRef.current = editor;
            actions.updateMonaco(monaco);
            actions.updateEditor(editor);
            actions.updateCodeParserLoading(true);
            initTheme(monaco);
            initModels(monaco, editor, modelInfos, dispatch);
            codeParser = new CodeParser(editorApiRef.current, stateRef.current);
            _context.next = 9;
            return codeParser.parseVersion.init();
          case 9:
            actions.setCodeParser(codeParser);
            actions.updateCodeParserLoading(false);
            registerCommandsAndActions(monaco, editor);
            registerListeners(editor, editorApiRef.current, stateRef.current);
          case 13:
          case "end":
            return _context.stop();
        }
      }, _callee);
    }));
    return _handleEditorDidMount.apply(this, arguments);
  }
  function handleEditorBeforeMount(monaco) {
    monacoRef.current = monaco;
    registerLangs(monaco, stateRef.current);
  }
  useEffect(function () {
    editorApiRef.current.addErrorMarker = function (errors, from) {
      if (from === void 0) {
        from = id;
      }
      var allMarkersPerfile = {};
      for (var _iterator = _createForOfIteratorHelperLoose(errors), _step; !(_step = _iterator()).done;) {
        var error = _step.value;
        var _filePath = error.file;
        if (!_filePath) return;
        var _model = findModel(stateRef.current.models || [], _filePath);
        var errorServerityMap = {
          'error': MarkerSeverity.Error,
          'warning': MarkerSeverity.Warning,
          'info': MarkerSeverity.Info
        };
        if (_model) {
          var markerData = {
            severity: typeof error.severity === 'string' ? errorServerityMap[error.severity] : error.severity,
            startLineNumber: error.position.start && error.position.start.line || 0,
            startColumn: error.position.start && error.position.start.column || 0,
            endLineNumber: error.position.end && error.position.end.line || 0,
            endColumn: error.position.end && error.position.end.column || 0,
            message: error.message
          };
          if (!allMarkersPerfile[_filePath]) {
            allMarkersPerfile[_filePath] = [];
          }
          allMarkersPerfile[_filePath].push(markerData);
        }
      }
      for (var filePath in allMarkersPerfile) {
        var model = findModel(stateRef.current.models || [], filePath);
        if (model) {
          var _monacoRef$current;
          (_monacoRef$current = monacoRef.current) == null ? void 0 : _monacoRef$current.editor.setModelMarkers(model.model, from, allMarkersPerfile[filePath]);
        }
      }
    };
  }, []);
  return React.createElement(React.Fragment, null, React.createElement(TopBar, {
    modelInfos: modelInfos
  }), React.createElement(ReactBaseMonacoEditor, {
    height: "90vh",
    onMount: handleEditorDidMount,
    beforeMount: handleEditorBeforeMount,
    defaultLanguage: "solidity",
    defaultValue: "// some comment"
  }));
}

function Editor(_ref) {
  var modelInfos = _ref.modelInfos,
    id = _ref.id;
  return React.createElement(DndProvider, {
    backend: HTML5Backend
  }, React.createElement(EditorProvider, null, React.createElement(App, {
    modelInfos: modelInfos,
    id: id
  })));
}

// import React, { FC, HTMLAttributes, ReactChild } from 'react';

export default Editor;
//# sourceMappingURL=solive.esm.js.map
