import BaseMonaco, { editor } from 'monaco-editor';
import { ErrorMarker } from '../libs/compiler/types';
export declare type BaseMonacoEditor = BaseMonaco.editor.IStandaloneCodeEditor;
export declare type ModelsInfoType = ModelInfoType[];
export declare type ModelType = ModelInfoType & {
    model: editor.ITextModel;
};
export declare enum SupportLanguage {
    Solidity = "solidity"
}
export declare class ModelInfoType {
    notInitial?: boolean;
    shown?: boolean;
    readOnly?: boolean;
    tested?: boolean;
    filename: string;
    value: string;
    language: SupportLanguage;
    constructor({ notInitial, shown, readOnly, tested, filename, value, language, }?: Partial<ModelInfoType>);
}
export interface EditorApi {
    addErrorMarker: (errors: ErrorMarker[], from?: string) => void;
}
